/////////////////////////////////////////////////////
//Boden-Klasse. Die Bodenelemte sind unbeweglich!
//////////////////////////////////////////////////////
class Boden {
  // Zum Speichern der Boden-Koordinaten
  ArrayList<Vec2> bodenRechts;
  ArrayList<Vec2> bodenLinks;
  float winkel ;

  Boden() {
    bodenRechts = new ArrayList<Vec2>();
    bodenLinks = new ArrayList<Vec2>();

    // Realisierung der beiden Boden-Teile
    ChainShape ketteRechts = new ChainShape();
    ChainShape ketteLinks = new ChainShape();
       
    //Boden rechts
    winkel = 0;   
    for (float x = width; x > width/2+85; x -= 5) {
      //Funktion Parabel überlagert von Sinus:
      float y = -((x-400)/20)*((x-400)/20)+50*sin(0.08*x)+550;
      winkel += 0.15;
      // Speichern der Ketten-Koordinaten 
      bodenRechts.add(new Vec2(x,y));
    }
    //Aus ArrayList-Elementen wird Array in Box2D-Koordinaten gebildet
    Vec2[] verticesR = new Vec2[bodenRechts.size()];
    for (int i = 0; i < verticesR.length; i++) {
      Vec2 punkt = box2d.coordPixelsToWorld(bodenRechts.get(i));
      verticesR[i] = punkt;
    }    
    // Erzeugung einer "Kette"
    ketteRechts.createChain(verticesR,verticesR.length);
    //Das Ende einer Kette wird durch eine "fixture" an den body angeheftet
    BodyDef bdR = new BodyDef();
    bdR.position.set(0.0,0.0);
    Body bodyR = box2d.createBody(bdR);
    bodyR.createFixture(ketteRechts,1);

    
    //Boden links
    winkel = 0;    
    for (float x = -10; x <  width/2-65 ; x += 5) {
      float y = -((x-400)/20)*((x-400)/20)+50*sin(0.08*x)+550;
      winkel += 0.15;
      //Speicherung der Fenster-Koordinaten
      bodenLinks.add(new Vec2(x,y));//if (x>=600)println(x,y); 
    }  
   //Aus ArrayList-Elementen wird Array in Box2D-Koordinaten gebildet
    Vec2[] verticesL = new Vec2[bodenLinks.size()];
    for (int i = 0; i < verticesL.length; i++) {
      Vec2 punkt = box2d.coordPixelsToWorld(bodenLinks.get(i));
      verticesL[i] = punkt;
    }    
    //Erzeugung einer "Kette"
    ketteLinks.createChain(verticesL,verticesL.length);

   //Das Ende einer Kette wird durch eine "fixture" an den body angeheftet
    BodyDef bdL = new BodyDef();
    bdL.position.set(0.0,0.0);
    Body bodyL = box2d.createBody(bdL);
    bodyL.createFixture(ketteLinks,1);
  }

  // Zeichnen der Ketten durch ihre Vertices
  void display() {
    strokeWeight(8);
    stroke(255);
    noFill();
    //Zeichnen des Bodens rechts
    beginShape();
    for (Vec2 v: bodenRechts) {
      vertex(v.x,v.y);
    }
    endShape();
    //Zeichnen des Bodens links
    beginShape();
    for (Vec2 v: bodenLinks) {
      vertex(v.x,v.y);
    }
    endShape();
  }
}